:
# generate a start/stop script boilerplate

test "$1" || { echo usage $0 "name" "default" >&2; exit 1; }

target=`basename $1`
it=${2:-$target}
name=`basename $it`

toUpper() {
        ${TR:-tr} abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ
}

NAME=`echo $name | toUpper`
TARGET=`echo $target | toUpper`
RCSid='$Id: proto.SH,v 1.17 2006/03/20 20:35:34 sjg Exp $'
YEAR=`date +%Y 2>/dev/null`
YEAR=${YEAR:-`date +20%y`} # is it still possible that %Y doesn't work?

cat <<!EOH!
:
# NAME:
#	$target - start/stop/check $name
#
# DESCRIPTION:
#	This script start/stop/checks $name.
#
# SEE ALSO:
#	
#
# AUTHOR:
#	Simon J. Gerraty <sjg@crufty.net>

# RCSid:
#	\$Id: proto.SH,v 1.17 2006/03/20 20:35:34 sjg Exp $
#	From: `echo "$RCSid" | ${TR:-tr} -d '\$'`
#
#	@(#) Copyright (c) $YEAR Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

# pick up zap()
RC_D=\${RC_D:-/etc/rc_d}
. \$RC_D/funcs.sh

# need to set Myname
Myname=$target
source .\${Myname}rc \$Mydir \$RC_D /etc

$NAME=\${$NAME:-\`Which $name\`}
$NAME=\${$NAME:-$it}
test -x \$$NAME || exit 0	# nothing to do
NAME=\`basename \$$NAME\`

# list of processes to stop
STOP="\$NAME"

Start() {
	\$$NAME \$${NAME}_OPTS & Echo -n " \$NAME"
}
!EOH!
cat <<'!EOF!'

Stop() {
	zap $STOP
}

case "$0" in
*check*)
	cmd=check;;
*)	cmd=$1;;
esac

case "$cmd" in
""|start)	# default is start
	Start
	exit $?
	;;
esac
# everything else relies on $name running.
pids=${pids:-`get_pids $STOP`}

case "$cmd" in
check)
	if test "$pids" && kill -0 $pids 2>/dev/null; then
		exit 0
	fi
	Echo -n "restarting"
	Start
	echo
	;;
stop)
	test "$pids" && Stop
	;;
restart)
	test "$pids" && Stop
	Echo -n "restarting"
	Start
	;;
esac
!EOF!
